﻿package com{
	import flash.display.MovieClip;
	import flash.events.*;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	import flash.geom.ColorTransform;
	import flash.geom.Rectangle;
	import flash.utils.Timer;
    import flash.events.TimerEvent;
	import flash.utils.getDefinitionByName;

	public class Dice {
		private var targetClip:MovieClip;
		private var xmlData:XML;
		private var diceCount:Number;
		private var resultArr:Array;
		private var diceArr:Array;
		private var sw:Number=760;
		private var diceSides:Number = 0;
		
		public function Dice(target:MovieClip):void {
			targetClip = target;
			targetClip.visible = false;
			xmlData = new XML();
			diceCount = 1;
			resultArr = new Array();
			diceArr = new Array();
		}
		public function setUp(url:String):void {
			enableBtns(false);
			loadXML(url);
		}		
		private function randomRange(prevRndNum:Number,max:Number, min:Number = 0):Number
		{
			if(max == min) return max;
			var currRnd:Number = Math.round(Math.random() * (max - min) + min);
			var prevRnd:Number = prevRndNum;
			if(prevRnd == currRnd){
				currRnd = randomRange(prevRnd,max,min);
			}	
			return currRnd;
		}	 
		private function enableBtns(val:Boolean):void{
			targetClip.reset_btn.enabled = val;
			targetClip.showResultBtn.enabled = val;
			targetClip.rollBtn.enabled = val;
			targetClip.selDiceBtn.enabled = val;
			targetClip.sixBtn.enabled = val;
			targetClip.tenBtn.enabled = val;
			
			if(val){
				targetClip.reset_btn.addEventListener(MouseEvent.CLICK,function(){reset();});
				
				for(var i:Number=0;i<4;i++){
					if(i<xmlData.dices.children().length()){
						targetClip.btnClip["btn_"+i].gotoAndStop(1);
						targetClip.btnClip["btn_"+i].visible = true;
						targetClip.btnClip["btn_"+i].addEventListener(MouseEvent.CLICK,onBtnClicked);
					}else{
						targetClip.btnClip["btn_"+i].visible = false;
					}
				}			
				
				targetClip.showResultBtn.buttonMode = true;					
				targetClip.showResultBtn.gotoAndStop(1);
				targetClip.showResultBtn.addEventListener(MouseEvent.CLICK,function(){
					if(targetClip.showResultBtn.currentFrame == 1){
						targetClip.showResultBtn.gotoAndStop(2);
					}else{
						targetClip.showResultBtn.gotoAndStop(1);
					}
					showHideResult();
				});
				
				targetClip.rollBtn.buttonMode = true;
				targetClip.rollBtn.gotoAndStop(1);
				targetClip.rollBtn.addEventListener(MouseEvent.CLICK,function(){
					for(i=0;i<diceCount;i++){
						resultArr[i][0].val = Number(resultArr[i][0].val) + 1;
						showResult(i,0);
					}
					var dicesClip:MovieClip = targetClip.getChildByName("dicesClip") as MovieClip;
					for(i=0;i<diceCount;i++){
						var diceClip:MovieClip = dicesClip.getChildByName("diceClip_"+i) as MovieClip;	
							diceClip.addEventListener(Event.ENTER_FRAME,startAnimation);
					}
				});
				
				targetClip.selDiceBtn.buttonMode = true;
				targetClip.selDiceBtn.gotoAndStop(1);
				targetClip.selDiceBtn.addEventListener(MouseEvent.CLICK,function(){
					targetClip.sixBtn.visible = !targetClip.sixBtn.visible;
					targetClip.tenBtn.visible = !targetClip.tenBtn.visible;
					targetClip.btnClip.visible = !targetClip.btnClip.visible;
				});
				
				targetClip.sixBtn.gotoAndStop(1);
				targetClip.sixBtn.addEventListener(MouseEvent.CLICK,function(){
					targetClip.sixBtn.gotoAndStop(2);
					targetClip.tenBtn.gotoAndStop(1);
					addDice();
					updateResultArr();
				});
				
				targetClip.tenBtn.gotoAndStop(1);
				targetClip.tenBtn.addEventListener(MouseEvent.CLICK,function(){
					targetClip.sixBtn.gotoAndStop(1);
					targetClip.tenBtn.gotoAndStop(2);
					addDice();
					updateResultArr();
				});
			}
		}
		private function showHideResult(){
			var resultClip:MovieClip = targetClip.getChildByName("resultClip") as MovieClip;
			if(resultClip!=null){
				if(targetClip.showResultBtn.currentFrame == 1){
					resultClip.visible = false;
				}else{
					resultClip.visible = true;
				}
			}
		}
		private function startAnimation(e:Event):void{
			var diceId:Number = Number(e.target.name.split("_")[1]);
			var dicesClip:MovieClip = targetClip.getChildByName("dicesClip") as MovieClip;
			var diceClip:MovieClip = dicesClip.getChildByName("diceClip_"+diceId) as MovieClip;
			diceClip.removeEventListener(Event.ENTER_FRAME,startAnimation); 
			var myTimer:Timer = new Timer(100,10);
			myTimer.addEventListener(TimerEvent.TIMER, function(){rollDice(diceClip);});	
			myTimer.addEventListener(TimerEvent.TIMER_COMPLETE,function(){	
				var totalCount:Number = 0;
				var id:Number = getIndex(diceId, diceArr[diceId]);
				resultArr[diceId][id].val = Number(resultArr[diceId][id].val) + 1;
				showResult(diceId,id);
			});
			myTimer.start();
		}
		private function getIndex(ind:Number, num:Number):Number{
			var id:Number;
			for(var j=0;j<=diceSides;j++){
				if(resultArr[ind][j].id == num){
					id = j;
					break;
				}
			}
			return id;
		}
		private function rollDice(diceClip:MovieClip):void{	
			var id:Number = Number(diceClip.name.split("_")[1]);
			var len:Number;
			if(targetClip.sixBtn.currentFrame==2){
				len = 5;
			}else{
				len = 9;
			}
			var rolledNum:Number = randomRange(Number(diceArr[id]),0,len);			
			diceArr[id] = rolledNum + 1;
			var rolledNum2:Number = randomRange(Number(diceArr[id]),0,len);
			var rolledNum3:Number = randomRange(Number(diceArr[id]),0,len);
			
			while(rolledNum==rolledNum2 || rolledNum==rolledNum3 || rolledNum2==rolledNum3)
			{
				rolledNum= randomRange(Number(diceArr[id]),0,len);			
				diceArr[id] = rolledNum + 1;
				rolledNum2= randomRange(Number(diceArr[id]),0,len);
				rolledNum3= randomRange(Number(diceArr[id]),0,len);
				
			}
			//trace(rolledNum,rolledNum2,rolledNum3)
			drawPageContent(targetClip.sixBtn.currentFrame,rolledNum,diceClip.top);
			drawPageContent(targetClip.sixBtn.currentFrame,rolledNum2,diceClip.left);
			drawPageContent(targetClip.sixBtn.currentFrame,rolledNum3,diceClip.right);
		}
		private function onBtnClicked(e:MouseEvent):void{
			targetClip.btnClip["btn_"+(diceCount-1)].gotoAndStop(1);
			diceCount = Number(e.target.name.split("_")[1]) + 1;
			addDice();			
			targetClip.btnClip["btn_"+(diceCount-1)].gotoAndStop(3);			
			updateResultArr();
		}
		private function updateResultArr():void {
			if(targetClip.sixBtn.currentFrame==2){
				diceSides = 6;
			}else{
				diceSides = 10;
			}
			resultArr = new Array;
			for(var i:Number=0; i<diceCount; i++){	
				resultArr[i] = {};
				resultArr[i][0] = ({id:"Roll",val:0});
			}
			for(i=0; i<diceCount; i++){		
				for(var j:Number = 0; j <= diceSides+1; j++){
					resultArr[i][j+1] = ({id:j+1,val:0});
				}
			}
			drawResult();
		}
		private function loadXML(path:String) {
			var urlRequest:URLRequest=new URLRequest(path);
			var urlLoader:URLLoader=new URLLoader(urlRequest);
			urlLoader.addEventListener(Event.COMPLETE, xmlLoaded);
		}
		private function xmlLoaded(e:Event):void {
			xmlData = new XML(e.target.data);
			enableBtns(true);			
			reset();
			showHideResult();
			targetClip.visible = true;
		}
		public function reset():void {
			targetClip.tenBtn.visible = false;
			targetClip.sixBtn.visible = false;			
			targetClip.btnClip.visible = false;	
			targetClip.sixBtn.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
			targetClip.btnClip["btn_0"].dispatchEvent(new MouseEvent(MouseEvent.CLICK));			
		}		
		private function resizePage(page:MovieClip, w:Number, h:Number):void {
			page.bg.x=0;
			page.bg.y=0;
			page.bg.width=w;
			page.bg.height=h;			
			//if (page.border.visible) {
				page.border.right.height=h;
				page.border.top.width=w;
				page.border.left.height=h;
				page.border.bottom.width=w;

				page.border.left.x=0;
				page.border.left.y=0;
				page.border.top.x=0;
				page.border.top.y=0;

				page.border.right.x=page.border.top.x+page.border.top.width-page.border.right.width;
				page.border.right.y=0;
				page.border.bottom.x=0;
				page.border.bottom.y=page.border.left.y+page.border.left.height-page.border.bottom.height;
			//}
		}
		private function drawPage(w:Number, h:Number, fillColor:Number, fillAlpha:Number, borderSize:Number, borderColor:Number):MovieClip {
			var page:Page = new Page();
			var pageColorTrans:ColorTransform = new ColorTransform();
			pageColorTrans.color=fillColor;
			page.bg.transform.colorTransform=pageColorTrans;
			page.bg.alpha=fillAlpha;
			page.border.visible = (borderSize>0) ? true : false;
			if (page.border.visible) {
				var borderColorTrans:ColorTransform = new ColorTransform();
				borderColorTrans.color=borderColor;
				page.border.transform.colorTransform=borderColorTrans;

				page.border.left.width=borderSize;
				page.border.right.width=borderSize;
				page.border.top.height=borderSize;
				page.border.bottom.height=borderSize;
			}
			resizePage(page,w,h);
			return page;
		}
		private function drawDice(fillColor:Number,shadowColor:Number, fillAlpha:Number, borderSize:Number, borderColor:Number):MovieClip {
			var diceObj;
			if(targetClip.sixBtn.currentFrame == 2) diceObj = new dice();
			else diceObj = new diamond();
			var diceColorTrans:ColorTransform = new ColorTransform();
			diceColorTrans.color = fillColor;
			diceObj.top.bg.transform.colorTransform = diceColorTrans;
			var shadowColorTrans:ColorTransform = new ColorTransform();
			shadowColorTrans.color = shadowColor;
			diceObj.left.bg.transform.colorTransform = diceObj.right.bg.transform.colorTransform = shadowColorTrans;
			diceObj.top.bg.alpha = diceObj.left.bg.alpha = diceObj.right.bg.alpha = fillAlpha;
			diceObj.top.border.visible = diceObj.left.border.visible = diceObj.right.border.visible = (borderSize>0) ? true : false;
			if (borderSize>0) {
				var borderColorTrans:ColorTransform = new ColorTransform();
				borderColorTrans.color=borderColor;
				diceObj.top.border.transform.colorTransform=diceObj.left.border.transform.colorTransform=diceObj.right.border.transform.colorTransform=borderColorTrans;

			}
			return diceObj;
		}
		private function addDice():void {
			if(targetClip.getChildByName("dicesClip")!=null) targetClip.removeChild(targetClip.getChildByName("dicesClip"));
			var dicesClip:MovieClip = new MovieClip(); 
			dicesClip.name = "dicesClip";
			var row:Number = Number(xmlData.dices.@row);
			var col:Number = Number(xmlData.dices.@col);
			var gap:Number = Number(xmlData.dices.@gap);
			for(var i=0;i<diceCount;i++){
				var diceClip:MovieClip = drawDice(Number(xmlData.dices.dice[i].@bgColor),Number(xmlData.dices.dice[i].@shadowColor), ((xmlData.dices.dice[i].@bgColor=="")?0:1), Number(xmlData.dices.dice[i].@borderSize), Number(xmlData.dices.dice[i].@borderColor));
				diceClip.name="diceClip_"+i;
				diceArr[i] = 0;
				
				if(targetClip.sixBtn.currentFrame==2){
					if(xmlData.dices.@sixDiceWidth.toString().length>0) diceClip.width = Number(xmlData.dices.@sixDiceWidth);
					if(xmlData.dices.@sixDiceHeight.toString().length>0) diceClip.height = Number(xmlData.dices.@sixDiceHeight);
					drawPageContent(targetClip.sixBtn.currentFrame,4,diceClip.left);
					drawPageContent(targetClip.sixBtn.currentFrame,3,diceClip.right);
					
				}else{
					if(xmlData.dices.@tenDiceWidth.toString().length>0) diceClip.width = Number(xmlData.dices.@tenDiceWidth);
					if(xmlData.dices.@tenDiceHeight.toString().length>0) diceClip.height = Number(xmlData.dices.@tenDiceHeight);
					drawPageContent(targetClip.sixBtn.currentFrame,8,diceClip.left);
					drawPageContent(targetClip.sixBtn.currentFrame,6,diceClip.right);
				}
				diceClip.x = (i%col) * (diceClip.width + gap);
				diceClip.y = (Math.floor(i/col) * (diceClip.height + gap));
				drawPageContent(targetClip.sixBtn.currentFrame,0,diceClip.top);
				dicesClip.addChild(diceClip);
			}
			dicesClip.x = (xmlData.dices.@x.toString().length>0) ? Number(xmlData.dices.@x) : ((sw - dicesClip.width)/2);
			dicesClip.y = Number(xmlData.dices.@y);
			targetClip.addChild(dicesClip);
		}
		private function changeFormat(targetTxt:TextField,font:String,fontSize:Number,fontColor:uint,align:String=null):void{
			var txt:TextField = targetTxt;
			var txtFormat:TextFormat = new TextFormat();
			txtFormat.leftMargin = 0;
			txtFormat.rightMargin = 0;
			var f=getDefinitionByName(font) as Class;
			var fnt=new f();
			
			txtFormat.font = fnt.fontName;
			/*txtFormat.bold = true;*/
			txtFormat.size = fontSize;
			txtFormat.color = fontColor;
			if(align!=null) txtFormat.align = align;
			txt.setTextFormat(txtFormat);
			txt.embedFonts=true;
		}
		private function addTxt(txtStr:String):TextField{
			var txt:TextField = new TextField();
			txt.selectable = false;
			txt.background = false;
			txt.border = false;
			txt.autoSize = TextFieldAutoSize.LEFT;
			txt.text = txtStr;
			return txt;
		}
		private function drawPageContent(cType:Number,pageNo:Number,targetPage:MovieClip):void {
			var parentClip:MovieClip = targetPage.parent as MovieClip;
			var pageCont:MovieClip = targetPage.getChildByName("pageCont") as MovieClip;
			if(pageCont!=null) targetPage.removeChild(pageCont);
			pageCont = new MovieClip();
			pageCont.name="pageCont";			
			if (cType==1) {
				var txt:TextField = addTxt((pageNo+1).toString());
				txt.name="txt";				
				if(targetPage.name != "top"){
					changeFormat(txt,xmlData.contents.@font,Number(xmlData.contents.@fontSize)/2,uint(xmlData.contents.@fontColor));
					txt.embedFonts = true;
					if(targetPage.name == "left"){
						pageCont.x = 45 - txt.width/2;
						pageCont.y = 40;					
						pageCont.rotation = 30;
						if(Number(txt.text) < 10){
							pageCont.x = 45 - txt.width/2 + 5;
							pageCont.y = 45;
						}else{
							pageCont.x = 45 - txt.width/2;
							pageCont.y = 40;
						}
					}else{
						if(Number(txt.text) < 10){
							pageCont.x = 55;
							pageCont.y = 60;
						}else{
							pageCont.x = 68;
							pageCont.y = 65;
						}
						pageCont.scaleX *= -1;
						pageCont.rotation = 30;						
					}					
				}else{
					changeFormat(txt,xmlData.contents.@font,Number(xmlData.contents.@fontSize),uint(xmlData.contents.@fontColor));
					pageCont.x = (targetPage.width - pageCont.width - txt.width)/2;
					pageCont.y = (targetPage.height - pageCont.height - txt.height)/2 + 10;
				}
				pageCont.addChild(txt);
			} else {
				var numOfContents:Number=xmlData.contents.content[pageNo].child(targetPage.name).children().length();
				
				if (numOfContents>0) {
					for (var j:Number=0; j<numOfContents; j++) {
						var cont:MovieClip = new MovieClip();
						cont.name="cont_"+j;
						
						cont.graphics.lineStyle(Number(xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@borderSize), Number(xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@borderColor), (Number(xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@borderSize)==0)?0:1);
						cont.graphics.beginFill(Number(xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@bgColor), 1);
						cont.graphics.drawEllipse(0,0,Number(xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@width),Number(xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@height));
						var xDist:Number=Number(xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@x);
						var yDist:Number=Number(xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@y);
						cont.x = xDist;
						cont.y = yDist;
						cont.rotation = (xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@rotation.toString().length>0) ? Number(xmlData.contents.content[pageNo].child(targetPage.name).dot[j].@rotation) : 0;
									
						pageCont.addChild(cont);

					}
					pageCont.x = 0;
					pageCont.y = 0;
				}
			}			
			targetPage.addChild(pageCont);
			targetPage.mouseChildren=false;
		}
		private function drawResult():void{
			if(targetClip.getChildByName("resultClip")!=null) targetClip.removeChild(targetClip.getChildByName("resultClip"));		
			var resultClip:MovieClip = new MovieClip();
			resultClip.name = "resultClip";
			var xPos:Number = 0;
			var yPos:Number = 0;
			var counter:Number;
			for(var i=0;i<resultArr.length;i++){
				var DiceResultClip:MovieClip = new MovieClip();
				DiceResultClip.name = "diceRes_" + i;
				if(targetClip.sixBtn.currentFrame==2){
					xPos = Number(xmlData.answers.sixSided.answer[i].@xPos.split(",")[i]);
					yPos = Number(xmlData.answers.sixSided.answer[i].@yPos.split(",")[i]);
				}else{
					xPos = Number(xmlData.answers.tenSided.answer[i].@xPos.split(",")[i]);
					yPos = Number(xmlData.answers.tenSided.answer[i].@yPos.split(",")[i]);
				}
				for(var j=0; j <= diceSides; j++){
					var left:MovieClip;
					if(j==0){
						left= drawPage(Number(xmlData.answers.sixSided.answer[0].@width), Number(xmlData.answers.sixSided.answer[0].@height), Number(xmlData.dices.dice[i].@bgColor),((xmlData.answers.@bgColor=="")?0:1), Number(xmlData.answers.@borderSize), Number(xmlData.answers.@borderColor));
					}else{
						left = drawPage(Number(xmlData.answers.sixSided.answer[0].@width), Number(xmlData.answers.sixSided.answer[0].@height), Number(xmlData.answers.@bgColor),((xmlData.answers.@bgColor=="")?0:1), Number(xmlData.answers.@borderSize), Number(xmlData.answers.@borderColor));
					}
					left.name = "left_"+i;
					var txt1:TextField = addTxt(resultArr[i][j].id);
					txt1.name="txt";
					changeFormat(txt1,xmlData.answers.@font,Number(xmlData.answers.@fontSize),uint(xmlData.answers.@fontColor));
					left.addChild(txt1);	
					DiceResultClip.addChild(left);
										
					left.x = xPos;
					left.y = yPos;
					yPos = yPos + Number(xmlData.answers.sixSided.answer[0].@height) - 2;
					txt1.x = (left.width - txt1.width)/2;
					txt1.y = (left.height - txt1.height)/2;
					resultClip.addChild(left);
					
					var right:MovieClip
					if(j==0){
						right = drawPage(Number(xmlData.answers.sixSided.answer[0].@width), Number(xmlData.answers.sixSided.answer[0].@height), Number(xmlData.dices.dice[i].@bgColor),((xmlData.answers.@bgColor=="")?0:1), Number(xmlData.answers.@borderSize), Number(xmlData.answers.@borderColor));
					}else{
						right = drawPage(Number(xmlData.answers.sixSided.answer[0].@width), Number(xmlData.answers.sixSided.answer[0].@height), Number(xmlData.answers.@bgColor),((xmlData.answers.@bgColor=="")?0:1), Number(xmlData.answers.@borderSize), Number(xmlData.answers.@borderColor));
					}
					right.name = "right_"+i+"_"+j;
					var txt2:TextField = addTxt("0");
					txt2.name="txt";		
					txt2.visible = false;
					right.addChild(txt2);
					right.border.left.visible = false;
					right.x = left.x + left.width;
					right.y = left.y;
					txt2.x = (right.width - txt2.width)/2;
					txt2.y = (right.height - txt2.height)/2;
					DiceResultClip.addChild(right);;			
				}
				resultClip.addChild(DiceResultClip);
				
			}
			resultClip.x = Number(xmlData.answers.@x);
			resultClip.y = Number(xmlData.answers.@y);
			targetClip.addChild(resultClip);
			for(i=0;i<diceCount;i++){
				showResult(i,0);
			}
			showHideResult();
		}
		private function showResult(index:Number, index1:Number):void{
			var resultClip:MovieClip = targetClip.getChildByName("resultClip") as MovieClip;
			var diceResultClip:MovieClip = resultClip.getChildByName("diceRes_"+index) as MovieClip;
			var right:MovieClip = diceResultClip.getChildByName("right_"+index+"_"+index1) as MovieClip;
			var txt:TextField = right.getChildByName("txt") as TextField;
			txt.text = resultArr[index][index1].val.toString();
			changeFormat(txt,xmlData.answers.@font,Number(xmlData.answers.@fontSize),uint(xmlData.answers.@fontColor));
			txt.x = (right.width - txt.width)/2;
			//txt.y = (right.height - txt.height)/2;
			txt.y =0;			
			txt.visible = true;
		}
	}
}