﻿package com
{
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.Graphics;
	import flash.filters.DropShadowFilter;
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.geom.Rectangle;
	import flash.display.LineScaleMode;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.text.TextFormatAlign;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;
	public class NumberExpander extends MovieClip
	{
		private var XMLObj:XML=new XML();
		private var MaximumDigits:Number;
		private var MinimumDigits:Number;
		private var NumDigits:Number;
		private var GenRandomNumber:Number=0;
		private var NumberExpanderMC:MovieClip=new MovieClip();
		private var CalculationMC:MovieClip=new MovieClip();
		private var DigitsArray:Array=new Array();
		private var LabelsArray:Array=new Array();
			
		private var sw:Number=760;
		private var sh:Number=530;
		
		public function NumberExpander()
		{
			LoadActivityXML();
		}
		private function LoadActivityXML():void
		{
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/NTO4_7.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLObj=XML(e.target.data);
			
			MaximumDigits=Number(XMLObj.NumberExpander.@maximumDigits);
			MinimumDigits=Number(XMLObj.NumberExpander.@minimumDigits);
			NumDigits=MaximumDigits;
			
			GenRandomNumber=randomRange(Math.pow(10,(NumDigits-1)),Math.pow(10,NumDigits)-1);
			LabelsArray=XMLObj.Labels.split(",");
			
			addChild(NumberExpanderMC);
			addChild(CalculationMC);
			//AddBottomPanel();
			CreateNumberExpander();
			AddAllBtns();
			AddResetBtn();		
		}
		private function AddBottomPanel():void
		{
			var sh:Shape=new Shape();
			var g:Graphics=sh.graphics;
			g.lineStyle(XMLObj.BottomPanel.@linethickness,XMLObj.BottomPanel.@linecolor);
			g.drawRect(0,0,XMLObj.BottomPanel.@width,XMLObj.BottomPanel.@height);
			addChild(sh);
			sh.x=XMLObj.BottomPanel.@xpos;
			sh.y=XMLObj.BottomPanel.@ypos;
		}
		private function AddAllBtns():void
		{
			var Btn1:addNumberBtn=new addNumberBtn();
			var Btn2:removeNumberBtn=new removeNumberBtn();
			var Btn3:RandomNumber=new RandomNumber();
			var Btn4:TypingBox=new TypingBox();
			var Btn5:SetNumber=new SetNumber();
			
			Btn1.name="add";
			Btn2.name="remove";
			Btn3.name="random";
			Btn4.name="box";
			Btn5.name="set";
			
			Btn1.x=XMLObj.Buttons.Plus1.@xpos;
			Btn1.y=XMLObj.Buttons.Plus1.@ypos;	
			Btn1.addEventListener(MouseEvent.CLICK,AddDigit);
			StatusBtn(Btn1,false);
			
			Btn2.x=XMLObj.Buttons.Minus1.@xpos;
			Btn2.y=XMLObj.Buttons.Minus1.@ypos;
			Btn2.addEventListener(MouseEvent.CLICK,RemoveDigit);			
			
			Btn3.x=XMLObj.Buttons.RandomNumber.@xpos;
			Btn3.y=XMLObj.Buttons.RandomNumber.@ypos;
			Btn3.addEventListener(MouseEvent.CLICK,CreateRandomNumber);
			
			Btn4.x=XMLObj.Buttons.TypingBox.@xpos;
			Btn4.y=XMLObj.Buttons.TypingBox.@ypos;
			
			Btn5.x=XMLObj.Buttons.SetNumber.@xpos;
			Btn5.y=XMLObj.Buttons.SetNumber.@ypos;
			Btn5.addEventListener(MouseEvent.CLICK,SetRandomNumber);
			
			addChild(Btn1);
			addChild(Btn2);
			addChild(Btn3);
			addChild(Btn4);
			addChild(Btn5);
			
			Btn4.txt.text="";
			Btn4.txt.maxChars=7;
			Btn4.txt.restrict="0-9";
			Btn4.txt.addEventListener(Event.CHANGE,onNumberChanged);
			
			Btn5.mouseEnabled=false;
			Btn5.alpha=0.5;
		}
		private function CreateNumberExpander():void
		{
			DigitsArray=new Array();
			for(var s:int=NumberExpanderMC.numChildren-1;s>=0;s--)
			{
				NumberExpanderMC.removeChildAt(s);
			}
			RemoveResult();
			
			var sha:Shape=new Shape();
			sha.name="bg";			
			NumberExpanderMC.addChild(sha);			
				
			var StartX:Number=0;
			
			var Str:String=GenRandomNumber.toString();
			if(Str.length<NumDigits && NumDigits>1)
			{
				while(Str.length<NumDigits)
				{
					Str="0"+Str;
				}
			}
			
			var gr:Graphics=sha.graphics;
			gr.lineStyle(XMLObj.NumberExpander.@lineThickness,XMLObj.NumberExpander.@borderColor,1);
			gr.beginFill(XMLObj.NumberExpander.@fillColor,1);
			gr.drawRect(0,0,Number(XMLObj.NumberExpander.@boxWidth)*NumDigits,XMLObj.NumberExpander.@boxHeight);
			gr.endFill();
			
			for(var i:int=0;i<NumDigits;i++)
			{
				var mc:MovieClip=new MovieClip();
				var sh:Shape=new Shape();
				var g:Graphics=sh.graphics;
				g.lineStyle(XMLObj.NumberExpander.@lineThickness,XMLObj.NumberExpander.@borderColor,0);
				g.beginFill(XMLObj.NumberExpander.@fillColor,0);
				g.drawRect(0,0,XMLObj.NumberExpander.@boxWidth,XMLObj.NumberExpander.@boxHeight);
				g.endFill();
				mc.addChild(sh);
				mc.x=StartX;
				
				var txt:TextField=CreateTextField(XMLObj.NumberExpander.@FontId,Number(XMLObj.NumberExpander.@FontSize),uint(XMLObj.NumberExpander.@FontColor));
				txt.text=Str.charAt(i);
				mc.addChild(txt);
				txt.x=(mc.width-txt.width)/2;
				txt.y=(mc.height-txt.height)/2;
				
				var dl:Shape=CreateDashedLine(Number(XMLObj.NumberExpander.@boxHeight)+2,6,3,Number(XMLObj.NumberExpander.@lineThickness),uint(XMLObj.NumberExpander.@lineColor));
				mc.addChild(dl);
				
				mc.index=(NumDigits-i-1);
				mc.clicked=false;
				
				mc.xpos=mc.x;
				mc.ypos=mc.y;
				
				mc.buttonMode=true;
				mc.mouseChildren=false;
				mc.addEventListener(MouseEvent.CLICK,ExpandIt);
				
				StartX+=Number(XMLObj.NumberExpander.@boxWidth);
				NumberExpanderMC.addChild(mc);
				
				DigitsArray.push(mc);
			}
			NumberExpanderMC.x=(sw-NumberExpanderMC.width)/2;
			NumberExpanderMC.y=XMLObj.NumberExpander.@ypos;
		}		
		private function ExpandIt(e:MouseEvent):void
		{
			var tar=e.currentTarget;
			if(!tar.clicked)
			{
				tar.clicked=true;
			}else
			{
				tar.clicked=false;
			}
			DigitsArray[DigitsArray.length-1].mouseEnabled=false;
			DigitsArray[DigitsArray.length-1].clicked=true;
			
			var bg=NumberExpanderMC.getChildByName("bg");
			
			var StartX:Number=0;
			var Str:String=GenRandomNumber.toString();
			if(Str.length<NumDigits && NumDigits>1)
			{
				while(Str.length<NumDigits)
				{
					Str="0"+Str;
				}
			}
			var cnt:int=0;
			for(var i:int=0;i<DigitsArray.length;i++)
			{
				if(DigitsArray[i].clicked)
				{			
					cnt++;
					var exp=DigitsArray[i].getChildByName("exp");
					if(exp)
					{
						DigitsArray[i].removeChild(exp);
					}
					var mc:MovieClip=new MovieClip();
					mc.name="exp";
					var sh:Shape=new Shape();					
					mc.addChild(sh);
					var txt:TextField=CreateTextField(XMLObj.Labels.@FontId,Number(XMLObj.Labels.@FontSize),uint(XMLObj.Labels.@FontColor));
					txt.htmlText=LabelsArray[DigitsArray[i].index];
					mc.addChild(txt);					
					
					var g:Graphics=sh.graphics;
					g.lineStyle(XMLObj.NumberExpander.@lineThickness,XMLObj.NumberExpander.@borderColor,0);
					g.beginFill(XMLObj.NumberExpander.@fillColor,0);
					g.drawRect(0,0,2*Number(XMLObj.NumberExpander.@boxWidth),DigitsArray[i].height);
					g.endFill();
					
					txt.x=(mc.width-txt.width)/2;
					txt.y=(mc.height-txt.height)/2;
					
					var dl:Shape=CreateDashedLine(Number(XMLObj.NumberExpander.@boxHeight)+2,2,2,Number(XMLObj.NumberExpander.@lineThickness),uint(XMLObj.NumberExpander.@lineColor));
					mc.addChild(dl);
					dl.x=(mc.width-dl.width)/2;		
					
					dl=CreateDashedLine(Number(XMLObj.NumberExpander.@boxHeight)+2,6,3,Number(XMLObj.NumberExpander.@lineThickness),uint(XMLObj.NumberExpander.@lineColor));
					mc.addChild(dl);
					
					mc.x=DigitsArray[i].width;
					DigitsArray[i].addChild(mc);					
				}else
				{
					exp=DigitsArray[i].getChildByName("exp");
					if(exp)
					{
						DigitsArray[i].removeChild(exp);
					}
				}
			}
			StartX=0;
			for(i=0;i<DigitsArray.length;i++)
			{
				DigitsArray[i].x=StartX;
				StartX+=DigitsArray[i].width;
			}
			
			bg.graphics.clear();
			var gr:Graphics=bg.graphics;
			gr.lineStyle(XMLObj.NumberExpander.@lineThickness,XMLObj.NumberExpander.@borderColor,1);
			gr.beginFill(XMLObj.NumberExpander.@fillColor,1);
			gr.drawRect(0,0,NumberExpanderMC.width,XMLObj.NumberExpander.@boxHeight);
			gr.endFill();
			
			NumberExpanderMC.x=(sw-NumberExpanderMC.width)/2;
			NumberExpanderMC.y=XMLObj.NumberExpander.@ypos;
			
			RemoveResult();
			
			if(cnt==DigitsArray.length)
			{
				StartX=0;
				Str=GenRandomNumber.toString();
				for(i=Str.length-1;i>=0;i--)
				{
					mc=new MovieClip();
					var re:Shape=new Shape();
					mc.addChild(re);				
					
					mc.x=StartX;
					
					txt=CreateTextField(XMLObj.Result.@FontId,Number(XMLObj.Result.@FontSize),uint(XMLObj.Result.@FontColor));
					var tempExpanderStr:String=""+Number(Str.charAt(Str.length-i-1))*Math.pow(10,i);
					
					txt.htmlText = AddSpaceInExpander(tempExpanderStr);
					mc.addChild(txt);				
						
					g=re.graphics;
					g.lineStyle(XMLObj.Rect.@linethickness,XMLObj.Rect.@lineColor);
					g.beginFill(XMLObj.Rect.@fillcolor,1);
					g.drawRect(0,0,txt.width+2,txt.height);
					g.endFill();
					
					txt=CreateTextField(XMLObj.Result.@FontId,Number(XMLObj.Result.@FontSize),uint(XMLObj.Result.@FontColor));
					if(i==0)
					{						
						txt.htmlText="=";
					}else
					{
						txt.htmlText="+";
					}					
					
					txt.x=mc.width+5;							
					mc.addChild(txt);	
								
					ApplyShadowFilter(re);					
					CalculationMC.addChild(mc);					
					StartX+=mc.width+5;
					if(i==0)
					{
						mc=new MovieClip();
						re=new Shape();
						mc.addChild(re);	
						txt=CreateTextField(XMLObj.Result.@FontId,Number(XMLObj.Result.@FontSize),uint(XMLObj.Result.@FontColor));
						var resultTxt:String = Str;
						var expandStr:Array = [];
						for(var ii:Number = 0; ii < resultTxt.length; ii++){
							expandStr.push(resultTxt.substr(ii, 1));
							if(ii%3 == 0){
								expandStr.push(" ");
							}
						}
						resultTxt = expandStr.join("");
						txt.htmlText=resultTxt;
						mc.addChild(txt);	
						g=re.graphics;
						g.lineStyle(XMLObj.Rect.@linethickness,XMLObj.Rect.@lineColor);
						g.beginFill(XMLObj.Rect.@fillcolor,1);
						g.drawRect(0,0,txt.width+2,txt.height);
						g.endFill();
						ApplyShadowFilter(re);	
						mc.x=StartX;
						CalculationMC.addChild(mc);		
					}
					
				}
				
				CalculationMC.x=(sw-CalculationMC.width)/2;
				CalculationMC.y=XMLObj.Result.@ypos; 
			}
		}
		
		private function AddSpaceInExpander(expanderStr:String):String{
			var resultTxt:String = expanderStr;
			var expandStr:Array = [];
			for(var ii:Number = resultTxt.length-1; ii >= 0; ii--){
				expandStr.push(resultTxt.substr(ii, 1));
				if(ii%3 == 0){
					expandStr.push(" ");
				}
			}			
			if(expandStr.length > 2){
				var tempStr:String = expandStr[expandStr.length - 2];
				expandStr[0] = tempStr;
				expandStr[expandStr.length - 2] = 0;
			}
			resultTxt = "";
			resultTxt = expandStr.join("");
			return resultTxt.substr(0, resultTxt.length-1);
		}
		private function ApplyShadowFilter(Obj:Shape):void
		{
			var SF:DropShadowFilter=new DropShadowFilter();
			SF.blurX=XMLObj.Rect.@blurX;
			SF.blurY=XMLObj.Rect.@blurY;
			SF.angle=XMLObj.Rect.@shadowAngle;
			SF.distance=XMLObj.Rect.@shadowDistance;
			SF.color=XMLObj.Rect.@shadowColor;
			SF.alpha=XMLObj.Rect.@shadowAlpha;	
			Obj.filters=[SF];
		}
		private function RemoveResult():void
		{
			for(var s:int=CalculationMC.numChildren-1;s>=0;s--)
			{
				CalculationMC.removeChildAt(s);
			}
		}
		private function AddResetBtn():void
		{			
			/*addChild(res);
			res.x=XMLObj.Buttons.ResetBtn.@xpos;
			res.y=XMLObj.Buttons.ResetBtn.@ypos;*/
			reset_btn.addEventListener(MouseEvent.CLICK,Reset);		
		}
		private function CreateTextField(FID:String,Size:Number,color:uint):TextField
		{
			var TxtFld:TextField=new TextField();
			TxtFld.name="txt";
			TxtFld.type="dynamic";
			TxtFld.selectable=false;
			TxtFld.multiline=false;	
			TxtFld.autoSize="left";
			
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			var TF:TextFormat=new TextFormat();
			
			var FontC=getDefinitionByName(FID) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=Size;
			TF.color=color;

			TxtFld.defaultTextFormat=TF;	
			TxtFld.embedFonts=true;
			
			return TxtFld;			
		}
		private function AddDigit(e:MouseEvent):void
		{
			if(NumDigits<MaximumDigits)
			{
				NumDigits++;
				var Num:Number=randomRange(1,9);
				GenRandomNumber=GenRandomNumber+(Num*Math.pow(10,NumDigits-1));
				CreateNumberExpander();
			}
			var tar=getChildByName("box");
			tar.txt.text="";
			EditDigitButtonsStatus();
			
		}
		private function RemoveDigit(e:MouseEvent):void
		{	
			if(NumDigits>MinimumDigits)
			{						
				if(NumDigits==GenRandomNumber.toString().length)
				{				
					GenRandomNumber=GenRandomNumber-(Number(GenRandomNumber.toString().charAt(0))*Math.pow(10,GenRandomNumber.toString().length-1));	
				}
				
				NumDigits--;	
				
				CreateNumberExpander();
			}
			var tar=getChildByName("box");
			tar.txt.text="";
			EditDigitButtonsStatus();					
		}
		private function EditDigitButtonsStatus():void
		{
			var button=getChildByName("add");
			StatusBtn(button,true);
			
			var button2=getChildByName("remove");
			StatusBtn(button2,true);
			
			if(NumDigits==MaximumDigits)
			{				
				StatusBtn(button,false);
			}else
			{
				StatusBtn(button,true);
			}
			
			if(NumDigits==MinimumDigits)
			{				
				StatusBtn(button2,false);
			}else
			{
				StatusBtn(button2,true);
			}
		}
		private function CreateRandomNumber(e:MouseEvent=null):void
		{
			GenRandomNumber=randomRange(Math.pow(10,(NumDigits-1)),Math.pow(10,NumDigits)-1);
			CreateNumberExpander();
			var tar=getChildByName("box");
			tar.txt.text="";
		}
		private function SetRandomNumber(e:MouseEvent):void
		{
			var btn1=getChildByName("set");
			StatusBtn(btn1,false);
			var tar=getChildByName("box");
			GenRandomNumber=Number(tar.txt.text);
			NumDigits=tar.txt.text.length;
			CreateNumberExpander();
			EditDigitButtonsStatus();
		}
		private function onNumberChanged(e:Event):void
		{
			var tar=getChildByName("box");
			var btn1=getChildByName("set");
			if(tar.txt.text!="")
			{
				StatusBtn(btn1,true);
			}else
			{
				StatusBtn(btn1,false);
			}
		}
		private function StatusBtn(Btn:*,Status:Boolean):void
		{
			Btn.mouseEnabled=Status;
			Btn.alpha=(Status)?1:0.5;
		}
		private function CreateDashedLine(lh:Number,ds:Number,ss:Number,lth:Number,lc:uint):Shape
		{
			var lineHeight:Number = lh,
			controlHeight:Number = 0,
			dashSize:Number = ds,
			spaceSize:Number =ss;
			var Sp:Shape=new Shape();
			
			Sp.graphics.lineStyle(lth, lc, 0.5, true, LineScaleMode.NONE);
			
			while (controlHeight < lineHeight - dashSize) {
			Sp.graphics.lineTo(0,controlHeight + dashSize);
			controlHeight += dashSize
			
			Sp.graphics.moveTo( 0,controlHeight + spaceSize);
			controlHeight += spaceSize;
			}			
			return Sp;
		}
		private function randomRange(minNum:Number, maxNum:Number):Number  
		{  
			return (Math.floor(Math.random() * (maxNum - minNum + 1)) + minNum);  
		} 
		private function Reset(e:MouseEvent):void
		{
			NumDigits=MaximumDigits;
			CreateRandomNumber();
			EditDigitButtonsStatus();
			var tar=getChildByName("box");
			tar.txt.text="";
			var btn1=getChildByName("set");
			StatusBtn(btn1,false);
			RemoveResult();
		}
	}
}