﻿package com
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.display.Graphics;
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.geom.Rectangle;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TextEvent;
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.text.TextFormatAlign;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;
	
	public class Thermometer extends MovieClip
	{
		private var XMLObj:XML=new XML();
		private var RandomArrayMC:MovieClip=new MovieClip();
		private var TotalItems:Number=new Number();
		private var Feedback:MovieClip;
		private var Feedback2:MovieClip;
		private var IndicatorHeight1:Number=0;
		private var IndicatorHeight2:Number=0;	
		private var CurrentTemp:Number=0;
		private var CurrentTemp2:Number=0;
		
		private var BtnsArray:Array=new Array();
		public function Thermometer()
		{
			LoadActivityXML();
		}
		private function LoadActivityXML():void
		{
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/NTO4_8.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLObj=XML(e.target.data);
			
			AddThermometer(1,XMLObj.Thermometer.@xpos1,XMLObj.Thermometer.@ypos1);
			//AddBottomPanel();
			AddAllButtons();
			AddResetBtn();
			AddCounter();
			
			
		}
		private function AddThermometer(Num:Number,xpos:Number,ypos:Number):void
		{
			var th:ThermometerMC=new ThermometerMC();
			th.x=xpos;
			th.y=ypos;
			addChild(th);
			
			th.name="tm"+Num;
			this["IndicatorHeight"+Num]=Math.round(th.bulb.indicator.height);
			th.bulb.indicator.height=0;
			CurrentTemp=0;
			
		}
		private function AddBottomPanel():void
		{
			var sh:Shape=new Shape();
			var g:Graphics=sh.graphics;
			g.lineStyle(XMLObj.BottomPanel.@linethickness,XMLObj.BottomPanel.@linecolor);
			g.drawRect(0,0,XMLObj.BottomPanel.@width,XMLObj.BottomPanel.@height);
			addChild(sh);
			sh.x=XMLObj.BottomPanel.@xpos;
			sh.y=XMLObj.BottomPanel.@ypos;
		}
		private function AddAllButtons():void
		{			
			var Num_Btns:Number=XMLObj.Buttons.Btn.length();
			for(var i:int=0;i<Num_Btns;i++)
			{
				var cl=getDefinitionByName(XMLObj.Buttons.Btn[i].@name) as Class;
				var mc=new cl();
				addChild(mc);
				
				mc.x=XMLObj.Buttons.Btn[i].@xpos;
				mc.y=XMLObj.Buttons.Btn[i].@ypos;
				mc.name=XMLObj.Buttons.Btn[i].@name;
				BtnsArray.push(mc);
			}
			BtnsArray[0].addEventListener(MouseEvent.CLICK,RandomTemperature1);
			BtnsArray[1].txt.addEventListener(Event.CHANGE,onTextInput1);
			BtnsArray[2].addEventListener(MouseEvent.CLICK,SetTemperature1);
			BtnsArray[3].addEventListener(MouseEvent.CLICK,Add2ndThermometer);
			BtnsArray[4].addEventListener(MouseEvent.CLICK,RandomTemperature2);
			BtnsArray[5].txt.addEventListener(Event.CHANGE,onTextInput2);
			BtnsArray[6].addEventListener(MouseEvent.CLICK,SetTemperature2);
			
			StatusBtn(BtnsArray[2],false);
			StatusBtn(BtnsArray[4],false);
			StatusBtn(BtnsArray[6],false);
			
			BtnsArray[1].txt.text=BtnsArray[5].txt.text="";
			
			BtnsArray[1].txt.maxChars=BtnsArray[5].txt.maxChars=3;
			
			BtnsArray[1].txt.restrict=BtnsArray[5].txt.restrict="0-9";
			
			BtnsArray[5].alpha=0.5;
			BtnsArray[5].txt.selectable=false;
		}
		private function RandomTemperature1(e:MouseEvent):void
		{
			var Temp:Number=randomRange(0,100);
			var th=getChildByName("tm1");
			th.bulb.indicator.height=(IndicatorHeight1/100)*Temp;
			CurrentTemp=Temp;
			RemoveFeedback();
			var txt=getChildByName("Counter");
			txt.text="";
		}
		private function SetTemperature1(e:MouseEvent):void
		{
			var Num=Number(BtnsArray[1].txt.text);
			if(Num>100)
			{
				Num=100;
			}
			var th=getChildByName("tm1");
			th.bulb.indicator.height=(IndicatorHeight1/100)*Num;
			StatusBtn(BtnsArray[2],false);
			CurrentTemp=Num;
			RemoveFeedback();
			var txt=getChildByName("Counter");
			txt.text="";
		}
		private function RandomTemperature2(e:MouseEvent):void
		{
			var Temp:Number=randomRange(0,100);
			var th=getChildByName("tm2");
			th.bulb.indicator.height=(IndicatorHeight1/100)*Temp;
			CurrentTemp2=Temp;
			var txt=getChildByName("Counter2");
			txt.text="";
			RemoveFeedback2();
		}
		private function SetTemperature2(e:MouseEvent):void
		{
			var Num=Number(BtnsArray[5].txt.text);
			if(Num>100)
			{
				Num=100;
			}
			var th=getChildByName("tm2");
			th.bulb.indicator.height=(IndicatorHeight1/100)*Num;
			StatusBtn(BtnsArray[6],false);
			CurrentTemp2=Num;
			var txt=getChildByName("Counter2");
			txt.text="";
			RemoveFeedback2();
		}
		private function onTextInput1(e:Event):void
		{
			(BtnsArray[1].txt.text!="")?StatusBtn(BtnsArray[2],true):StatusBtn(BtnsArray[2],false);
		}
		private function onTextInput2(e:Event):void
		{
			(BtnsArray[5].txt.text!="")?StatusBtn(BtnsArray[6],true):StatusBtn(BtnsArray[6],false);
		}
		private function Add2ndThermometer(e:MouseEvent):void
		{
			var tar=e.currentTarget;
			AddThermometer(2,XMLObj.Thermometer.@xpos2,XMLObj.Thermometer.@ypos2);
			AddCounter2();
			StatusBtn(tar,false);
			StatusBtn(BtnsArray[4],true);
			BtnsArray[5].alpha=1;
			BtnsArray[5].txt.selectable=true;
		}
		private function AddResetBtn():void
		{				
			//reset_btn.x=XMLObj.Reset.@xpos;
			//reset_btn.y=XMLObj.Reset.@ypos;
			reset_btn.addEventListener(MouseEvent.CLICK,Reset);		
		}
		private function AddCounter():void
		{
			var Txt:TextField=CreateInputText();
			Txt.name="Counter";
			Txt.width=XMLObj.Count.@width;
			Txt.height=XMLObj.Count.@height;
			Txt.x=XMLObj.Count.@xpos;
			Txt.y=XMLObj.Count.@ypos;
			Txt.maxChars=XMLObj.Count.@maxChars;
			Txt.restrict="0-9";
			addChild(Txt);
			Txt.addEventListener(Event.CHANGE,validateIt);
			
			var degSymbol:MovieClip = new degreesMC();
			degSymbol.name = "degreesMC";			
			degSymbol.x = Txt.x + Txt.width + 10;
			degSymbol.y = Txt.y + 5;			
			addChild(degSymbol);
			
			var celTxt:TextField = CreateTextField();
			celTxt.name = "celTxt";
			celTxt.text = "C";
			celTxt.x = degSymbol.x;
			celTxt.y = Txt.y + (Txt.height/2 - celTxt.height/2);
			addChild(celTxt);
		}
		private function AddCounter2():void
		{
			var Txt:TextField=CreateInputText();
			Txt.name="Counter2";
			Txt.width=XMLObj.Count.@width;
			Txt.height=XMLObj.Count.@height;
			Txt.x=XMLObj.Count.@xpos2;
			Txt.y=XMLObj.Count.@ypos2;
			Txt.maxChars=XMLObj.Count.@maxChars;
			Txt.restrict="0-9";
			addChild(Txt);
			Txt.addEventListener(Event.CHANGE,validateIt2);
			
			var degSymbol:MovieClip = new degreesMC();
			degSymbol.name = "degreesMC2";
			degSymbol.x = Txt.x + Txt.width + 10;
			degSymbol.y = Txt.y + 5;
			addChild(degSymbol);
			
			var celTxt:TextField = CreateTextField();
			celTxt.name = "celTxt2";
			celTxt.text = "C";
			celTxt.x = degSymbol.x;
			celTxt.y = Txt.y + (Txt.height/2 - celTxt.height/2);
			addChild(celTxt);
		}
		private function validateIt(e:Event):void
		{
			var tar=e.currentTarget;
			RemoveFeedback();
			if(tar.text!="")
			{
				if(Number(tar.text)==CurrentTemp)
				{
					Feedback=new correct();
				}else
				{
					Feedback=new wrong();
				}
				Feedback.x=XMLObj.Feedback.@xpos;
				Feedback.y=XMLObj.Feedback.@ypos;
				addChild(Feedback);
			}
		}
		private function validateIt2(e:Event):void
		{
			var tar=e.currentTarget;
			RemoveFeedback2();
			if(tar.text!="")
			{
				if(Number(tar.text)==CurrentTemp2)
				{
					Feedback2=new correct();
				}else
				{
					Feedback2=new wrong();
				}
				Feedback2.x=XMLObj.Feedback.@xpos2;
				Feedback2.y=XMLObj.Feedback.@ypos2;
				addChild(Feedback2);
			}
		}
		private function RemoveFeedback():void
		{
			try
			{
				if(Feedback)
				{
					removeChild(Feedback);
				}
			}catch(e:Error)
			{
			}
		}
		private function RemoveFeedback2():void
		{
			try
			{
				if(Feedback2)
				{
					removeChild(Feedback2);
				}
			}catch(e:Error)
			{
			}
		}
		private function CreateInputText():TextField
		{
			var TxtFld:TextField=new TextField();
			TxtFld.name="txt";
			TxtFld.type="input";
			TxtFld.border=true;
			//TxtFld.multiline=false;	
			
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			var TF:TextFormat=new TextFormat();
			TF.align=TextFormatAlign.CENTER;
			
			var FontC=getDefinitionByName(XMLObj.Count.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=XMLObj.Count.@FontSize;
			TF.color=XMLObj.Count.@FontColor;

			TxtFld.defaultTextFormat=TF;	
			TxtFld.embedFonts=true;
			
			return TxtFld;
			
		}
		private function CreateTextField():TextField
		{
			var TxtFld:TextField=new TextField();
			TxtFld.name="txt";
			TxtFld.type="dynamic";
			TxtFld.selectable=false;
			//TxtFld.multiline=false;	
			TxtFld.autoSize="left";
			
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			var TF:TextFormat=new TextFormat();
			
			var FontC=getDefinitionByName(XMLObj.Words.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=XMLObj.Words.@FontSize;
			TF.color=XMLObj.Words.@FontColor;

			TxtFld.defaultTextFormat=TF;	
			TxtFld.embedFonts=true;
			
			return TxtFld;
			
		}		
		private function randomRange(minNum:Number, maxNum:Number):Number  
		{  
			return (Math.floor(Math.random() * (maxNum - minNum + 1)) + minNum);  
		} 
		private function ResetInutField(mc:*):void
		{
			mc.txt.text="";
		}
		private function StatusBtn(Btn:*,Status:Boolean):void
		{
			Btn.mouseEnabled=Status;
			Btn.alpha=(Status)?1:0.5;
		}
		private function Reset(e:MouseEvent):void
		{
			RemoveFeedback();
			RemoveFeedback2();
			var txt=getChildByName("Counter");
			txt.text="";
			
			txt=getChildByName("Counter2");			
			
			if(txt)
			{
				removeChild(txt);
				removeChild(getChildByName("degreesMC2"));
				removeChild(getChildByName("celTxt2"));
			}
			
			StatusBtn(BtnsArray[2],false);
			StatusBtn(BtnsArray[4],false);
			StatusBtn(BtnsArray[6],false);
			
			var th=getChildByName("tm1");
			th.bulb.indicator.height=0;
			CurrentTemp=0;
			CurrentTemp2=0;
			
			th=getChildByName("tm2");
			if(th)
			{
				removeChild(th);
			}
			BtnsArray[1].txt.text="";
			BtnsArray[5].txt.text="";
			StatusBtn(BtnsArray[3],true);
			
			BtnsArray[5].alpha=0.5;
			BtnsArray[5].txt.selectable=false;
		}
	}
}